using System.Windows;

namespace GraphSharp.Algorithms.OverlapRemoval
{
	/// <summary>
	/// A System.Windows.Rect egy struktra, ezrt a heap-en troldik. Bizonyos esetekben ez nem
	/// szerencss, gy szksg van erre a wrapper osztlyra. Mivel ez class, ezrt nem
	/// rtk szerinti tads van.
	/// </summary>
	public class RectangleWrapper<TObject>
		where TObject : class
	{
		private readonly TObject id;
		public TObject Id
		{
			get { return id; }
		}

		public Rect Rectangle;

		/// <summary>
		/// 
		/// </summary>
		/// <param name="rectangle"></param>
		/// <param name="id">Az adott tglalap azonostja (az overlap-removal vgn tudnunk kell, hogy 
		/// melyik tglalap melyik objektumhoz tartozik. Az azonosts megoldhat lesz id alapjn.</param>
		public RectangleWrapper( Rect rectangle, TObject id )
		{
			Rectangle = rectangle;
			this.id = id;
		}

		public double CenterX
		{
			get { return Rectangle.Left + Rectangle.Width / 2; }
		}

		public double CenterY
		{
			get { return Rectangle.Top + Rectangle.Height / 2; }
		}

		public Point Center
		{
			get { return new Point( CenterX, CenterY ); }
		}
	}
}